<template lang="pug">
.login
  h1.login__title Авторизация
  Form(
    :items="fields"
    @input="input"
  )
  Button.login__button(
    type="main"
    @click="submit"
  ) Войти
  Error(v-if="error.status") {{ error.msg }}
</template>

<script>
import Form from '@/components/parts/Form.vue'
import Button from '@/components/parts/Button.vue'
import Error from '@/components/parts/Error.vue'

export default {
  name: 'Login',
  components: {
    Form,
    Button,
    Error
  },
  data() {
    return {
      fields: [
        {
          type: 'text',
          name: 'email',
          placeholder: 'mail@mail.ru',
          text: 'E-mail'
        },
        {
          type: 'password',
          name: 'password',
          placeholder: '••••••',
          text: 'Пароль'
        }
      ],
      email: '',
      password: '',
      error: {
        status: false,
        msg: 'Неверный логин или пароль'
      }
    }
  },
  methods: {
    input({ name, text }) {
      this[name] = text
    },
    async submit() {
      const { email, password } = this
      const username = email
      const user = { username, password }
      try {
        await this.$store.dispatch('login', user)
        this.$router.push({ name: 'Home' })
      } catch (e) {
        this.error.status = true
      }
    }
  }
}
</script>

<style lang="stylus" scoped>
.login
  text-align: center
  &__title
    margin: 30px 0 10px 0
  &__button
    margin: 20px 0
</style>
